﻿var ww = 0,	wh = 0;
var margin = 12;
var seekbar, play_time_label, track_length_label;

var zero_time = "00:00";

function TimeFmt(t) {
	if (t < 0) return zero_time;
	var zpad = function(n) {
			var str = n.toString();
			return (str.length < 2) ? "0" + str : str;
		}

	var m = Math.floor(t / 60);
	t -= m * 60, s = Math.floor(t);
	return zpad(m) + ":" + zpad(s);
}

function Format_hms(t) {
	if (t=="?") return zero_time;
	var hms;
	if (t) {
		switch (t.length) {
		case 4:
			hms = "0" + t;
			break;
		default:
			hms = t;
			break;
		}
		return hms;
	} else {
		return zero_time;
	}
}

function init_seek_bar() {
	// var sfont = get_font();
	
	var	font = gdi.Font(g_font_name, 13, FontStyle.Regular);	
	var label_w = GetTextWidth(zero_time, font);
	var label_h = GetTextHeight(zero_time, font);
	var track_len_x = ww- label_w - margin;

	// var length = fb.TitleFormat("[%length_seconds%]").Eval();
	// var track_length_text  =  length ?  TimeFmt (length) : zero_time;

	play_time_label = new Label(margin, 0, label_w, label_h, zero_time, font, seek_text_color, TextAlign.CALCRECT | TextAlign.VCENTER | TextAlign.RIGHT);
	track_length_label = new Label(track_len_x, 0, label_w, label_h, zero_time, font, seek_text_color, TextAlign.CALCRECT | TextAlign.VCENTER | TextAlign.RIGHT);

 	var seek_frame = gdi.CreateImage(200, 5);
	var gb = seek_frame.GetGraphics();
	gb.SetSmoothingMode(1);
	gb.FillSolidRect(0, 0, seek_frame.Width, seek_frame.Height, seek_frame_color);
	gb.SetSmoothingMode(0);
	seek_frame.ReleaseGraphics(gb);

	seek_time = gdi.CreateImage(200, 5);
	gb = seek_time.GetGraphics();
	gb.SetSmoothingMode(1);
	gb.FillSolidRect(0, 0, seek_time.Width, seek_time.Height, seek_time_color);
	gb.SetSmoothingMode(0);
	seek_time.ReleaseGraphics(gb);

	seeker = gdi.CreateImage(20, 20);
	gb = seeker.GetGraphics();
	gb.SetSmoothingMode(4);
	gb.FillEllipse(0, 0, 20, 20, seek_back_color);
	gb.FillEllipse(5, 5, 10, 10, seek_font_color);
	gb.SetSmoothingMode(0);
	seeker.ReleaseGraphics(gb);

	CollectGarbage();

	var seekbar_w = ww - 2*margin;
	var seekbar_y =  (wh-label_h > seeker.Height)? label_h : (wh - seeker.Height);
	seekbar = new Slider(margin, seekbar_y, seekbar_w, seeker.Height, seek_frame, seek_time, seeker, 5, seeker.Width, seeker.Height);
	seekbar.MaxValue = Math.max(0, fb.PlaybackLength);
	if (fb.IsPlaying) seekbar.SetValue(fb.PlaybackTime);
}

function on_size() {
	ww = window.Width;
	wh = window.Height;

	init_seek_bar();
}

function on_paint(gr) {
	play_time_label.Paint(gr);
	track_length_label.Paint(gr);
	seekbar.Paint(gr);
}

function on_mouse_move(x, y) {
	if (seekbar.MouseMove(x, y)){
		play_time_label.SetText(TimeFmt(seekbar.Value));
	}
}

function on_mouse_lbtn_down(x, y) {
	seekbar.MouseDown(x, y)
}

function on_mouse_lbtn_up(x, y) {
	if (seekbar.MouseUp()) {
		play_time_label.SetText(TimeFmt(seekbar.Value));
		fb.PlaybackTime = seekbar.Value;
	}
}

function on_mouse_leave() {

}

function on_mouse_wheel(step) {
	if (seekbar.MouseWheel(step, 2)) {
		play_time_label.SetText(TimeFmt(seekbar.Value));
		fb.PlaybackTime = seekbar.Value;
	}
}

function on_playback_pause(state) {
}

function on_playback_new_track(info) {
	track_length_label.SetText(TimeFmt(fb.PlaybackLength));
	seekbar.MaxValue = Math.max(0, fb.PlaybackLength);
	seekbar.SetValue(0);
}

function on_playback_stop(reason) {
	if (reason != 2) {
		play_time_label.SetText(zero_time);
		seekbar.MaxValue = 0;
		seekbar.SetValue(0);
	}
}

function on_playback_time(time) {
	play_time_label.SetText(TimeFmt(time));
	seekbar.SetValue(time);
}


function on_mouse_rbtn_up() {
	var mask = GetKeyboardMask();	
	if (mask == KMask.shift){
		return false;
	}else{
		return true;
	}
}