﻿/**************************************
 * 全局变量
 *************************************/
var ww = 0;
var wh = 0;
var music_title_text;
var music_album_text;

var play_btn, next_btn, prev_btn, vol_btn, vol_slider, love_btn, list_btn, lyric_btn, order_btn;
var last_vol = 0;

var Margin={
    Left : 6,
    Right : 6,
    Top : 4,
	Bottom : 4,
	Space: 6
}


/**************************************
 * 显示与控制
 *************************************/
function init_wsh_pannel(){
	init_title_text();
	init_play_button();
	init_love_rating();
	init_lyric_button();	
	init_list_button();
	init_order_button();
	init_vol_slider();
}

//歌曲信息显示
function init_title_text(){
    var title_text  = "歌曲";
    var artist_text = "艺术家";
    var album_text  = "专辑";
    var info_text = artist_text + "  " + album_text;

    var title_font = gdi.font(g_font_name, 21, g_fong_style);
	titile_x = Margin.Left;
	titile_y = Margin.Top;
	titile_w = ww - Margin.Left - Margin.Right;
	titile_h = GetTextHeight(title_text, title_font);
	music_title_text = new Label(titile_x, titile_y, titile_w, titile_h,title_text, title_font, play_title_color, TextAlign.CALCRECT | TextAlign.CENTER | TextAlign.VCENTER);

	var album_font = gdi.font(g_font_name, 15, g_fong_style);    	
	album_x = Margin.Left;
	album_y = Margin.Top + music_title_text.Height + Margin.Space;
	album_w = ww - Margin.Left - Margin.Right;
	album_h =  GetTextHeight(info_text, album_font);
	music_album_text = new Label(album_x, album_y, album_w, album_h, info_text, album_font, play_album_color, TextAlign.CALCRECT | TextAlign.CENTER | TextAlign.VCENTER)

	set_title_show();
}

function set_title_show(){
	if (!fb.IsPlaying) return;

	var title_text  = fb.TitleFormat("[%title%]").Eval();
	var artist_text = fb.TitleFormat("[%artist%]").Eval();
    var album_text  = fb.TitleFormat("[%album%]").Eval();
	var info_text = artist_text + "  " + album_text;
	
	music_title_text.SetText(title_text);	
	music_album_text.SetText(info_text);
}

//播放控制按钮
function init_play_button(){
	var v_space = 18;
	var h_space = 18;

	var play_w = 48;
	var play_h = 48;
	var play_x = (ww - play_h)/2;
	var play_y = (wh - play_h)/2 + v_space;
	play_btn = new Button(play_x, play_y, play_w, play_h, 
						play_normal_path, play_hover_path, play_pressed_path,
						on_play_clicked,
						"播放");

	set_play_show();

	var prev_w = 36;
	var prev_h = 36;
	var prev_x = play_btn.X - h_space - prev_w;
	var prev_y = play_btn.Y + play_btn.Height/2 - prev_h/2;
	prev_btn = new Button(prev_x, prev_y, prev_w, prev_h,
					prev_normal_path, prev_hover_path, prev_pressed_path,
					function(){fb.Prev()}, "上一首");
	
	var next_w = 36;
	var next_h = 36;
	var next_x = play_btn.X + play_btn.Width + h_space;
	var next_y = play_btn.Y + play_btn.Height/2 - next_h/2;
	next_btn = new Button(next_x, next_y,next_w, next_h, 
		next_normal_path, next_hover_path, next_pressed_path, 
		function(){ fb.Next()}, "下一首"); 
}

function on_play_clicked(){
	if (fb.IsPlaying && !fb.IsPaused){
		fb.Pause();
	}else{
		fb.Play();
	}
}


//显示按钮状态
function set_play_show(){
	if (fb.IsPlaying && !fb.IsPaused){
		play_btn.SetChecked(true);
		play_btn.SetTipText("暂停");
		play_btn.SetImage(pause_normal_path, pause_hover_path, pause_pressed_path);
	}else{
		play_btn.SetChecked(false);
		play_btn.SetTipText("播放");
		play_btn.SetImage(play_normal_path, play_hover_path, play_pressed_path);
	}
}

//喜欢歌曲
function init_love_rating(){
	var love_btn_w = 24;
	var love_btn_h = 24;
	var love_btn_x = 0;
	var love_btn_y = wh - Margin.Bottom - love_btn_h;	
	love_btn = new Button(love_btn_x, love_btn_y, love_btn_w, love_btn_h, love_not_path, null, null, on_love_clicked, "喜爱");
	set_love_show();
}

function on_love_clicked(){
	if (!fb.IsPlaying) return;
	
	if (love_btn.IsChecked){
		var metadb = fb.GetNowPlaying();
		metadb ? fb.RunContextCommandWithMetadb("Rating" + "/" + "<not set>", metadb) 
				|| fb.RunContextCommandWithMetadb("等级" + "/" + "<不设置>", metadb) 
				: null;
		love_btn.SetChecked(false);
		love_btn.SetImage(love_not_path, null, null);
	}else{
		var rate = 5;
		var metadb = fb.GetNowPlaying();
		metadb ? fb.RunContextCommandWithMetadb("Rating" + "/" + rate, metadb) 
				|| fb.RunContextCommandWithMetadb("等级" + "/" + rate, metadb) 
				: null;

		love_btn.SetChecked(true);
		love_btn.SetImage(love_normal_path, null, null);
	}
}

function set_love_show(){	
	if (!fb.IsPlaying) return;
	
	var metadb = fb.GetNowPlaying();	
	var rating	=   metadb? fb.TitleFormat("%rating%").EvalWithMetadb(metadb) : fb.TitleFormat("[%rating%]").Eval();
	rating   = rating == "?" ? 0 : rating;

	if (rating > 0){
		love_btn.SetChecked(true);
		love_btn.SetImage(love_normal_path, null, null);
	}else{
		love_btn.SetChecked(false);
		love_btn.SetImage(love_not_path, null, null);
	}
}

//桌面歌词按钮
function init_lyric_button(){
	var lyric_btn_w = 24;
	var lyric_btn_h = 24;
	var lyric_btn_x = love_btn.X + love_btn.Width + Margin.Space;	
	var lyric_btn_y = love_btn.Y + love_btn.Height/2 - lyric_btn_h/2;
	lyric_btn = new Button(lyric_btn_x, lyric_btn_y, lyric_btn_w, lyric_btn_h, lyric_normal_path, lyric_on_path, lyric_on_path, on_lyric_clicked, "歌词");
	set_lyric_show();
}

function on_lyric_clicked(){
	if (lyric_btn.IsChecked){
		lyric_btn.SetChecked(false);
		// lyric_btn.SetImage(lyric_normal_path, null, null);
		fb.RunMainMenuCommand("视图/ESLyric/显示桌面歌词");
	}else{
		lyric_btn.SetChecked(true);
		// lyric_btn.SetImage(lyric_normal_path, null, null);
		fb.RunMainMenuCommand("视图/ESLyric/显示桌面歌词");
	}
}

function set_lyric_show(){
	lyric_btn.SetChecked(false);
	lyric_btn.SetImage(lyric_normal_path, null, null);
}

//播放列表按钮
function init_list_button(){
	var list_btn_w = 24;
	var list_btn_h = 24;
	var list_btn_x = ww - list_btn_w;
	var list_btn_y = love_btn.Y + love_btn.Height/2 - list_btn_h/2;

	list_btn = new Button(list_btn_x, list_btn_y, list_btn_w, list_btn_h, list_normal_path, null, null, on_list_clicked, "播放列表");

	set_list_show();
}

function on_list_clicked(){
	if (list_btn.IsChecked){
		window.NotifyOthers(PLAY_LIST_SWITCH, false);
	}else{
		window.NotifyOthers(PLAY_LIST_SWITCH, true);
	}
}

function set_list_show(visible){
	if (visible){
		list_btn.SetChecked(true);
		list_btn.SetImage(list_on_path, null, null);
	}else{
		list_btn.SetChecked(false);
		list_btn.SetImage(list_normal_path, null, null);		
	}
}

//播放顺序
function init_order_button(){
	var order_btn_w = 24;
	var order_btn_h = 24;
	var order_btn_x = list_btn.X - Margin.Space - order_btn_w;	
	var order_btn_y = love_btn.Y + love_btn.Height/2 - order_btn_h/2;

	order_btn = new Button(order_btn_x, order_btn_y, order_btn_w, order_btn_h, order_a_path, null, null, on_order_clicked, "顺序播放");
	set_order_show();	
}

function on_order_clicked(){
	if (fb.PlaybackOrder == PlayOrder.Default){
		fb.PlaybackOrder = PlayOrder.Repeat_Playlist;
	}else if (fb.PlaybackOrder == PlayOrder.Repeat_Playlist){
		fb.PlaybackOrder = PlayOrder.Repeat_Track;
	}else if (fb.PlaybackOrder == PlayOrder.Repeat_Track){
		fb.PlaybackOrder = PlayOrder.Shuffle_tracks;
	}else if (fb.PlaybackOrder == PlayOrder.Shuffle_tracks){
		fb.PlaybackOrder = PlayOrder.Default;
	}else{
		fb.PlaybackOrder = PlayOrder.Default;
	}
}

function set_order_show(){
	switch(fb.PlaybackOrder){
		case PlayOrder.Default:
			order_btn.SetTipText("顺序播放");
			order_btn.SetImage(order_a_path, null, null);
			break;
		case PlayOrder.Repeat_Playlist:
			order_btn.SetTipText("循环");		
			order_btn.SetImage(order_b_path, null, null);
			break;
		case PlayOrder.Repeat_Track:
			order_btn.SetTipText("单曲循环");				
			order_btn.SetImage(order_c_path, null, null);
			break;	
		case PlayOrder.Shuffle_tracks:
			order_btn.SetTipText("随机");		
			order_btn.SetImage(order_d_path, null, null);
			break;
		default:
			order_btn.SetTipText("顺序播放");
			order_btn.SetImage(order_a_path, null, null);
			break;		
	}
}

//声音控制
function init_vol_slider(){
	var vol_frame = gdi.CreateImage(100, 5);
	gb = vol_frame.GetGraphics();
	gb.SetSmoothingMode(0);
	gb.FillSolidRect(0, 0, 100, 5, vol_frame_color);
	vol_frame.ReleaseGraphics(gb);

	var vol_active = gdi.CreateImage(100, 5);
	var gb = vol_active.GetGraphics();
	gb.SetSmoothingMode(0);
	gb.FillSolidRect(0, 0, 100, 5, vol_time_color);
	vol_active.ReleaseGraphics(gb);

	var imgh = 14;
	vol_seeker = gdi.CreateImage(imgh, imgh);
	gb = vol_seeker.GetGraphics();
	gb.SetSmoothingMode(4);
	gb.FillEllipse(0, 0, 14, 14, vol_back_color);
	gb.FillEllipse(4, 4, 6, 6, vol_font_color);
	gb.SetSmoothingMode(0);
	vol_seeker.ReleaseGraphics(gb);

	var vol_btn_w = 24;
	var vol_btn_h = 24;
	var vol_btn_x = lyric_btn.X + lyric_btn.Width + Margin.Space;
	var vol_btn_y = love_btn.Y + love_btn.Height/2 - vol_btn_h/2;

	vol_btn = new Button(vol_btn_x, vol_btn_y, vol_btn_w, vol_btn_h, vol_normal_path, null, null, on_vol_clicked, "音量");

	var vol_slider_h = vol_seeker.Height;
	var vol_slider_x = vol_btn.X + vol_btn.Width + vol_seeker.Width/2- Margin.Space;
	var vol_slider_y = vol_btn.Y + vol_btn.Height/2 - vol_slider_h/2;
	var vol_slider_w = order_btn.X - Margin.Space - vol_slider_x - vol_seeker.Width/2;
	vol_slider = new Slider(vol_slider_x, vol_slider_y, vol_slider_w, vol_slider_h, vol_frame, vol_active, vol_seeker, 2, vol_seeker.Width, vol_seeker.Height);
	vol_slider.MaxValue = 100;
	vol_slider.Value = vol2pos(fb.Volume) | 0;

	set_current_vol_show();
}

function set_current_vol_show(){
	if (vol2pos(fb.Volume) == 0){
		vol_btn.SetChecked(true);
		vol_btn.SetImage(vol_mute_path, null, null);	
	}else{		
		last_vol = fb.Volume;
		vol_btn.SetChecked(false);
		vol_btn.SetImage(vol_normal_path, null, null);
	}
}

function on_vol_clicked(){
	if (vol_btn.IsChecked){
		fb.Volume = last_vol;
		fb.VolumeUp();

		vol_btn.SetChecked(false);
		vol_btn.SetImage(vol_normal_path, null, null);
	}else{
		last_vol = fb.Volume;
		fb.Volume = pos2vol(0);
		vol_btn.SetChecked(true);
		vol_btn.SetImage(vol_mute_path, null, null);	
	}
}

/**************************************
 * wsh 回调
 *************************************/
function on_size(){
    ww = window.Width;
    wh = window.Height;    

    init_wsh_pannel();
}

function on_paint(gr){
   	var bg_color = RGBA(100, 90, 88, 255);

	// gr.FillSolidRect(0, 0, ww, wh, bg_color);

    music_title_text.Paint(gr);
    music_album_text.Paint(gr);

	play_btn.Paint(gr);
	prev_btn.Paint(gr);	
	next_btn.Paint(gr);

	love_btn.Paint(gr);
	lyric_btn.Paint(gr);	
	list_btn.Paint(gr);
	order_btn.Paint(gr);
	
	vol_btn.Paint(gr);
	vol_slider.Paint(gr);
}

function on_mouse_move(x, y) {
	play_btn.MouseMove(x, y);
	prev_btn.MouseMove(x, y);	
	next_btn.MouseMove(x, y);

	love_btn.MouseMove(x, y);
	lyric_btn.MouseMove(x, y);	
	list_btn.MouseMove(x, y);	
	order_btn.MouseMove(x, y);	

	vol_btn.MouseMove(x, y);
	if (vol_slider.MouseMove(x, y)) {
		fb.Volume = pos2vol(vol_slider.Value);
	}
}

function on_mouse_lbtn_down(x, y) {
	play_btn.MouseDown(x, y);
	prev_btn.MouseDown(x, y);	
	next_btn.MouseDown(x, y);

	love_btn.MouseDown(x, y);
	lyric_btn.MouseDown(x, y);		
	list_btn.MouseDown(x, y);		
	order_btn.MouseDown(x, y);

	vol_btn.MouseDown(x, y);
	if (vol_slider.MouseDown(x, y)) {
		fb.Volume = pos2vol(vol_slider.Value);
	}
}


function on_mouse_lbtn_up(x, y) {
	play_btn.MouseUp(x, y);
	prev_btn.MouseUp(x, y);
	next_btn.MouseUp(x, y);

	love_btn.MouseUp();
	lyric_btn.MouseUp();		
	list_btn.MouseUp();		
	order_btn.MouseUp();	
	
	vol_btn.MouseUp(x, y);
	vol_slider.MouseUp();
}

function on_mouse_lbtn_dblclk(x, y, mask) {
	window.NotifyOthers(NOW_PLAYING, true);
}

function on_mouse_leave() {
	play_btn.Reset();
	prev_btn.Reset();
	next_btn.Reset();

	love_btn.Reset();
	lyric_btn.Reset();		
	list_btn.Reset();		
	order_btn.Reset();	

	vol_btn.Reset();
}


function on_mouse_wheel(step) {
	if (vol_slider.MouseWheel(step, 2)) {
		fb.Volume = pos2vol(vol_slider.Value)
	}
}

function on_mouse_rbtn_up() {
	var mask = GetKeyboardMask();	
	if (mask == KMask.shift){
		return false;
	}else{
		return true;
	}
}

function on_playback_new_track(info) {
	set_title_show();
	set_play_show();
	set_love_show();	
}

function on_playback_pause(state) {
	set_play_show();
}

function on_playback_stop(reason) {
	set_play_show();
}

function on_volume_change(v) {
	vol_slider.SetValue(vol2pos(v) | 0);
	set_current_vol_show();
}

function on_playback_order_changed(new_order_index) {
	set_order_show();
}

/**************************************
 * wsh 系统通知
 *************************************/
function on_notify_data(name, info) {
	switch (name) {
	case PLAY_LIST_SWITCH:
		set_list_show(info);
		break;
	default:
		break;
	}
}