﻿

function RGBA(r, g, b, a) {
	return ((a << 24) | (r << 16) | (g << 8) | (b));
}

function RGB(r, g, b) {
	return (0xff000000 | (r << 16) | (g << 8) | (b))
}

function pos2vol(p) {
	return (50 * Math.log(0.99 * (p / 100) + 0.01) / Math.log(10));
}

function vol2pos(v) {
	return Math.round(((Math.pow(10, v / 50) - 0.01) / 0.99) * 100);
}

var FontStyle = {
    Regular: 0,
    Bold: 1,
    Italic: 2,
    BoldItalic: 3,
    Underline: 4,
    Strikeout: 8
};


var PlayOrder = {
    Default : 0,
    Repeat_Playlist : 1,
    Repeat_Track : 2,
    Random : 3,
    Shuffle_tracks : 4,
    Shuffle_albums : 5,
    Shuffle_folders : 6
}


var KMask = {
	none: 0,
	ctrl: 1,
	shift: 2,
	ctrlshift: 3,
	ctrlalt: 4,
	ctrlaltshift: 5,
	alt: 6
};

function GetKeyboardMask() {
	var c = utils.IsKeyPressed(VK_CONTROL) ? true : false;
	var a = utils.IsKeyPressed(VK_ALT) ? true : false;
	var s = utils.IsKeyPressed(VK_SHIFT) ? true : false;
	var ret = KMask.none;
	if (c && !a && !s)
		ret = KMask.ctrl;
	if (!c && !a && s)
		ret = KMask.shift;
	if (c && !a && s)
		ret = KMask.ctrlshift;
	if (c && a && !s)
		ret = KMask.ctrlalt;
	if (c && a && s)
		ret = KMask.ctrlaltshift;
	if (!c && a && !s)
		ret = KMask.alt;
	return ret;
};


// Used in window.GetColorCUI()
ColorTypeCUI = {
	text: 0,
	selection_text: 1,
	inactive_selection_text: 2,
	background: 3,
	selection_background: 4,
	inactive_selection_background: 5,
	active_item_frame: 6
};
// Used in window.GetFontCUI()
FontTypeCUI = {
	items: 0,
	labels: 1
};
// Used in window.GetColorDUI()
ColorTypeDUI = {
	text: 0,
	background: 1,
	highlight: 2,
	selection: 3
};
// Used in window.GetFontDUI()
FontTypeDUI = {
	defaults: 0,
	tabs: 1,
	lists: 2,
	playlists: 3,
	statusbar: 4,
	console: 5
};

function Font(){
    this.Name;
    this.Size;
    this.Style = FontStyle.Regular;
}

function get_font() {
    var font = null;
    var instancetype = window.InstanceType;
	if (instancetype == 0) {
		font = window.GetFontCUI(FontTypeCUI.items);
	} else if (instancetype == 1) {
		font = window.GetFontDUI(FontTypeDUI.playlists);
	};

	// tweak to fix a problem with WSH Panel Mod 1.5.6 and lower version on Font object Name property
	try {
	    var	fname = font.Name;
		var fsize = font.Size;
		var fstyle = font.Style;
	} catch (e) {
		fb.trace("WSH report: Unable to use your default font. Using Micosoft YaHei instead.");
        
        font = new Font();
        font.Name = "微软雅黑";
		font.Size = 12;
		font.Style = 0;
    };

    return nfont;
}
